function firefly_copier(action, paths, provider, targetPath, sourcePath, sourceProvider) {
	this.action = action;
	this.paths = paths;
	this.provider = provider;
	this.targetPath = targetPath;
	this.sourcePath = sourcePath;
	this.sourceProvider = sourceProvider;
	this.dirsAndFiles = new Array();
	this.dirs = new Array();
	this.files = new Array();
	this.pendingFiles = new Array();
	this.foldersToDel = new Array();
	this.filesDone = new Array();
	this.totalFileSize = 0;
	this.scanning = false;
	this.fileDone = true;
	this.hasPending = 0;
	this.startPos = -1;
	this.currentPending = -1;
	this.currentFilePosition = 0;
	this.currentFileSize = 0;
	this.currentFile = '';
	this.copiedSoFar = 0;
	this.currentFileIdx = 0;
	this.forAll = '';
	this.startTime = 0;
	this.copyNum = 0;
	this.transferDone = false;
	this.wrappedJSObject = this;	// can't access the copier from within listeners without this
	try {
		this.target = firefly_provider(provider, this.targetPath, true);
		for (var i = 0;i< paths.length;i++) {
			var afile = firefly_provider(provider, paths[i], true);
			if (afile.isDirectory()) {
				this.dirs.push(afile);
			} else {
				this.files.push(afile);
				this.totalFileSize = Math.ceil(this.totalFileSize) + afile.fileSize;
			}
		}
		this.dirsAndFiles = this.dirs.concat(this.files);		// for ask del i need the original dirs and files...
	} catch (e) {
		firefly_Logger(e,'error');
	}
}
firefly_copier.prototype.scanDirs = function() {
	try {
		if (this.scanning) {
			return;
		}
		this.scanning = true;
		if (this.dirs.length == 0) {
			this.doAction();
			this.scanning = false;
			dump('done scanning\r\n');
			return;
		}
		var currentDir = this.dirs.shift();
		var target = this.target;
		var currentPath = currentDir.path;
		// dump(currentDir.path + '\r\n');
		if (this.sourceProvider == 'file'){
			// var separator = firefly_getPref('pref', 'char', 'extensions.firefly.separator');
			var separator = '';
			var subpath = currentPath.substr(this.sourcePath.length + separator.length);
		}
		if (this.action == 'cut' || this.action == 'copy') {
			var newFolder = firefly_provider(this.provider, this.targetPath + subpath, true);
			newFolder.createFolder();
		}

		var [folderDirs,folderFiles,fileSize] = currentDir.getFolderEntries();
		this.dirs = this.dirs.concat(folderDirs);
		this.files = this.files.concat(folderFiles);
		this.totalFileSize = Math.ceil(this.totalFileSize) + fileSize;

		this.foldersToDel.push(currentDir);
		this.scanning = false;
		if (this.dirs.length > 0) {
			this.scanTimout = setTimeout('firefly_GetWindow().firefly_copy[' + this.copyNum + '].scanDirs()','1');
			// this.scanDirs();
		} else {
			this.doAction();
			dump('done scanning\r\n');
		}
	} catch (e) {
		firefly_Logger(e,'error');
	}
}
firefly_copier.prototype.doPending = function() {
	try {
		while (this.pendingFiles.length > 0) {
			var currentPending = this.pendingFiles.shift();
			if (this.forAll != '') {
				var params={action:this.forAll, additional:null};
			} else {
				var params={action:null, additional:null};
				window.openDialog("chrome://firefly/content/pendingDialog.xul", "showmore", "chrome,modal", currentPending, params);
				if (params.additional == 'forAll' && params.action != 'rename') {
					this.forAll = params.action;
				}
			}
			switch (params.action) {
				case 'rename':
					currentPending.copyAction = 'rename';
					var oldPath = currentPending.newFile.path;
					var parentPath = oldPath.substr(0, oldPath.length - currentPending.newFile.leafName.length);
					var newPath = parentPath + params.additional;
					currentPending.newPath = newPath;
					this.files.push(currentPending);
					break;
				case 'resume':
					currentPending.copyAction = 'resume';
					currentPending.newPath = currentPending.newFile.path;
					this.files.push(currentPending);
					break;
				case 'unique':
					currentPending.copyAction = 'unique';
					currentPending.newPath = currentPending.newFile.path;
					this.files.push(currentPending);
					break;
				case 'replace':
					currentPending.copyAction = 'replace';
					currentPending.newPath = currentPending.newFile.path;
					this.files.push(currentPending);
					break;
				case 'skip':
				default:
					break;
			}
		}
	} catch (e) {
		firefly_Logger(e,'error');
	}
}
firefly_copier.prototype.copy = function(currentFileIdx) {
	try {
		this.doPending();
		if (currentFileIdx == undefined) {
			currentFileIdx = 0;
		}
		while (this.files[currentFileIdx] == false) {
			currentFileIdx++;
		}
		if (this.fileDone && currentFileIdx < this.files.length) {
			// dump('currentFileIdx before: ' + this.currentFileIdx + '\r\n');
			this.currentFileIdx = currentFileIdx;
			// dump('currentFileIdx after: ' + this.currentFileIdx + '\r\n');
			// if previous copy is over and there are more files... set the variables
			this.fileDone = false;
			this.currentFile = this.files[currentFileIdx];
			// dump('currentFile for copy: ' + this.currentFile.path + '\r\n');
			this.currentFileSize = this.currentFile.fileSize;
			var path = this.currentFile.path;
			if (this.currentFile.pending == false || this.currentFile.pending == undefined || this.currentFile.pending == null) {
				var newPath = this.targetPath + path.substr(this.sourcePath.length);
			} else {
				var newPath = this.currentFile.newPath;
			}

			// dump('newPath: ' + newPath + '\r\n');

			var listener = {	// when transfer is complete set variables to defaults and start dirscan,copy
				finished : function(data,transferEl){
					transferEl = transferEl.wrappedJSObject;
					dump('finish copy: ' + transferEl.currentFile.path + '\r\n');
					transferEl.fileDone = true;
					transferEl.startPos = -1;
					transferEl.currentFilePosition = 0;
					transferEl.files[transferEl.currentFileIdx].doneCopy = true;
					transferEl.files[transferEl.currentFileIdx].pending = false;

					transferEl.copy(transferEl.currentFileIdx + 1);
				}
			}

			var newFile = firefly_provider(this.provider, newPath, true);

			// dump('newFile path: ' + newFile.path + '\r\n');

			if (!newFile.exists() || this.currentFile.copyAction == 'resume' || this.currentFile.copyAction == 'replace' || this.currentFile.copyAction == 'unique') {		//if file does't exist - create it
				if (this.currentFile.copyAction == 'replace') {
					newFile.delFile(false);
				}
				if (this.currentFile.copyAction != 'resume' && this.currentFile.copyAction != 'unique') {
					newFile.createFile();
				}
				if (this.currentFile.copyAction == 'unique') {
					newFile.createUniqueFile();
				}
				if (this.currentFile.copyAction == 'resume') {
					this.startPos = newFile.fileSize;
				}
				if (newFile.exists()) {
					// dump('newFile created: true\r\n');
					// dump('what is this:' + this.toSource() + '\r\n');
					this.currentFile.readFromStream(listener,newFile,this,this.startPos);		// actual copying is done here
					this.pump = this.currentFile.pump;
				} else {
					// dump('newFile created: false\r\n');
					dump('finish copy: ' + this.currentFile.path + ' - error\r\n');
					this.files[this.currentFileIdx].copyError = true;
					this.fileDone = true;
					this.copy(currentFileIdx + 1);
				}
			} else {
				this.files[this.currentFileIdx].pending = true;
				this.files[this.currentFileIdx].newFile = newFile;
				this.pendingFiles.push(this.files[this.currentFileIdx]);
				this.files[this.currentFileIdx] = false;
				this.fileDone = true;
				this.copy(currentFileIdx + 1);
			}
		} else {
			this.transferDone = true;
			dump('done copy\r\n');
			if (this.action == 'cut') {
				dump('start del\r\n');
				this.isDel = this.askDel();
				if (this.isDel) {
					dump('deleting\r\n');
					this.doDel();
				}
			}
		}
	} catch (e) {
		firefly_Logger(e,'error');
	}
}
firefly_copier.prototype.start = function() {
	try {
		dump('started copy/del\r\n');
		var time = new Date();
		this.startTime = time.getTime();
		if (this.action == 'del') {
			this.isDel = this.askDel();
		}
		this.scanDirs();
	} catch (e) {
		firefly_Logger(e,'error');
	}
}
firefly_copier.prototype.doFolders = function() {
	try {
		var currentDir = this.dirs.shift();
		var target = this.target;
		var currentPath = currentDir.path;
		// dump(currentDir.path + '\r\n');
		if (this.sourceProvider == 'file'){
			// var separator = firefly_getPref('pref', 'char', 'extensions.firefly.separator');
			var separator = '';
			var subpath = currentPath.substr(this.sourcePath.length + separator.length);
		}
		if (this.action == 'cut' || this.action == 'copy') {
			var newFolder = firefly_provider(this.provider, this.targetPath + subpath, true);
			newFolder.createFolder();
		}
		this.foldersToDel.push(currentDir);
		this.doFolders();
	} catch (e) {
		firefly_Logger(e,'error');
	}
}
firefly_copier.prototype.doAction = function() {
	try {
		if (this.action == 'del') {
			if (this.isDel) {
				dump('deleting\r\n');
				this.doDel();
			}
		} else if (this.action != 'del') {
			// this.doFolders();
			// return;
			this.copy();
		}
	} catch (e) {
		firefly_Logger(e,'error');
	}
}
firefly_copier.prototype.askDel = function() {
	try {
		// ask if sure to delete
		var dirsAndFiles = this.dirsAndFiles;
		var params={answer:null};
		window.openDialog("chrome://firefly/content/askDel.xul", "showmore", "chrome,modal", dirsAndFiles, params);
		if (params.answer == 'yes') {
			return true;
		} else {
			return false;
		}
	} catch (e) {
		firefly_Logger(e,'error');
	}
}
firefly_copier.prototype.doDel = function() {
	try {
		// var files = this.files;
		if (this.files.length > 0) {
			var file = this.files.shift();
			if (file !== false) {
				file.delFile(true);
			}
			setTimeout('firefly_GetWindow().firefly_copy[' + this.copyNum + '].doDel()','1');
			return;
		}

		var dirs = this.foldersToDel;
		if (this.foldersToDel.length > 0) {
			var dir = dirs.pop();
			dir.delFile(true);
			setTimeout('firefly_GetWindow().firefly_copy[' + this.copyNum + '].doDel()','1');
			return;
		}
		this.transferDone = true;
		dump('done deleting\r\n');
	} catch (e) {
		firefly_Logger(e,'error');
	}
}
