/* stuff to be done on load */
function firefly_OnLoad() {
	// NOTE: whether to show the log window
		var showLog = firefly_getPref('pref','bool','extensions.firefly.show_log');
		if (showLog) {
			firefly_ShowLog();
		}
	// NOTE: set starting data
		var fileboxes = firefly_getPref('tab','deserialize','fileboxes');
		if (fileboxes != '') {
			firefly_HandleRestore();
		} else {
			var currentFilebrowser = firefly_getPref('tab','deserialize','currentFilebrowser');
			if (currentFilebrowser == '') {																		// NOTE: check needed when restoring a tab!
				firefly_setPref('tab','serialize','currentFilebrowser','firefly_filebox_1');					// id of the first filebox
			}
			var maxIdNum = firefly_getPref('tab','deserialize','maxIdNum');
			if (maxIdNum == '') {																				// NOTE: check needed when restoring a tab!
				firefly_setPref('tab','serialize','maxIdNum',1);												// max id of the filebox - incremented every split
			}
			firefly_setPref('tab','serialize','fullScreen',false);												// is it fullscreen
			var fileboxes = firefly_getPref('tab','deserialize','fileboxes');
			if (fileboxes == '') {																				// NOTE: check needed when restoring a tab!
				var fileboxes = new Object();
				fileboxes['firefly_filebox_1'] = new Object();
				fileboxes['firefly_filebox_1']['matrix'] = '1';
				fileboxes['firefly_filebox_1']['path'] = '';
				fileboxes['firefly_filebox_1']['type'] = 'start';
				fileboxes['firefly_filebox_1']['provider'] = '';
				firefly_setPref('tab','serialize','fileboxes',fileboxes);
			}
		}
	// NOTE: if we have get path show it
		if (firefly_GET('path') != '') {
			// alert(firefly_GET('path'));
			var path = firefly_GET('path');
			path = path.replace(/%20/g,' ');
			if (path == 'start') {
				firefly_setPath('start','','');
			} else if (isAlias(path)) {
				showAlias(path);
			} else {
				firefly_setPath(firefly_getPref('pref', 'char', 'extensions.firefly.defaultView'),path,'file');
			}

		}
	// NOTE: load kbd shortcuts
		firefly_kbdShortcutsBuild();
}

window.addEventListener('load',firefly_OnLoad,false);

var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
var observeFileChange = {
	observe: function(subject,topic,data){
		try {
			if (topic != 'firefly_filesChange') {
				return;
			}
			var filesAndFolders = firefly_GetWindow().firefly_dataReturn[data];
			// alert(topic);
			// alert(data);
			// alert(filesAndFolders['folderDirs']);
			firefly_GetCurrent(data).dirs = filesAndFolders['folderDirs'];
			firefly_GetCurrent(data).files = filesAndFolders['folderFiles'];
			firefly_GetCurrent(data).filters = filesAndFolders['filters'];
			firefly_GetCurrent(data).buildFromFiles();
		} catch (e) {
		}
	},
	QueryInterface : function (aIID) {
		if (aIID.equals(Components.interfaces.nsIObserver) ||
			aIID.equals(Components.interfaces.nsISupports) ||
			aIID.equals(Components.interfaces.nsISupportsWeakReference))
			return this;
		throw Components.results.NS_NOINTERFACE;
	}

};
observerService.addObserver(observeFileChange,'firefly_filesChange',true);


var firefly_fileDrag = {
	onDragStart: function (event, transferData, action) {
		try {
			if (event.target.tagName == 'xul:hbox' || event.target.tagName == 'xul:listbox' || event.target.tagName == 'xul:listheader' || event.target.tagName == 'xul:splitter') {
				return true;
			}
			var selected = firefly_GetCurrent().getSelected();
			var paths = new Array();
			for (var k in selected) {
				paths.push(selected[k]['SingleFileBox'].file.path);
			}
			var transfer = new Object();
			transfer['provider'] = firefly_GetCurrent().getAttribute('provider');
			transfer['source'] = firefly_GetCurrent().path;
			transfer['paths'] = paths;
			transfer['action'] = 'copy';
			// transferData = firefly_makeTransferable('copy', paths, firefly_GetCurrent().path, firefly_GetCurrent().getAttribute('provider'));
			transferData.data = new TransferData();
			transferData.data.addDataForFlavour("application/firefly-paths", serialize(transfer));
		} catch (e) {
			firefly_Logger(e,'error');
		}
	},

	getSupportedFlavours: function () {
		try {
			var flavours = new FlavourSet();
			flavours.appendFlavour("application/firefly-paths");
			return flavours;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	},

	onDragOver: function (event, flavour, session) {},

	onDrop: function (event, dropdata, session) {
		if (dropdata.data != "") {
			var transfer = deserialize(dropdata.data);
			var action = transfer['action'];
			var paths = transfer['paths'];
			var source = transfer['source'];
			var sourceProvider = transfer['provider'];
			var current = event.currentTarget.parentNode.parentNode;
			firefly_doFiles(action, paths, current.path, current.getAttribute('provider'), source, sourceProvider);
		}
		return;
	}
};

// instances of firefly_player are recorded here. When we create new player first we have to remove the previous to avoid crashes
var globalPlayer = null;
