/**************** File Types ****************/

	/*	NOTE: ids of all setting entries
	 *
	*/
	var arrIds = new Array('pickColor', 'pickBold', 'pickItalic', 'filePrograms', 'moveUp', 'moveDown', '32picon', '16picon', 'addProgram',	'addProgramButton',
		'addProgramCaption', 'addProgramRelative', 'addProgramBrowse', 'fontBox', 'exampleStyle', 'setDefaultProgram', 'removeProgramButton', 'editProgramButton');


	/*	NOTE: add file type to the list
	 *	return true/false depending if a type name has been entered
	*/
	function addFileType() {
		try {
			var newTypeEl = document.getElementById('addtype');
			var newType = document.getElementById('addtype').value;
			if (newType != ''){
				/*var fileTypes = firefly_getPref('pref','complex','extensions.firefly.fileTypes');
				fileTypes = deserialize(fileTypes);
				if (fileTypes == null) {
					fileTypes = new Object();
				}
				if (fileTypes[newType] == null) {
					fileTypes[newType] = new Object();
					fileTypes[newType]['ext'] = newType;
				}
				fileTypes = serialize(fileTypes);
				firefly_setPref('pref','complex','extensions.firefly.fileTypes',fileTypes);*/


				var fileTypesList = document.getElementById('fileTypesList');
				for (var i = 0;i< fileTypesList.childNodes.length;i++) {
					if (fileTypesList.childNodes[i]['object']['ext'] == newType) {
						return false;		// if that extension exists return without doing nothing - if desired to change the extension use rename
					}
				}
				/*var newFileType = document.createElement('listitem');
				newFileType.setAttribute('label', newType);
				newFileType['object'] = new Object();
				newFileType['object']['ext'] = newType;*/

				var newObject = new Object();
				newObject['ext'] = newType;
				newObject['type'] = document.getElementById('mainType').value;
				var newFileType = createTypeListItem(newObject);

				fileTypesList.appendChild(newFileType);

				newTypeEl.value = '';
				document.getElementById('mainType').value = 'other';
				document.getElementById('addtype').focus();

				// loadFileTypesList();
				setTimeout("firefly_fireEvent('change',document.getElementById('fileTypesList'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
				return true;
			}
		} catch (e) {
			firefly_Logger(e,'error');
		}
		return false;
	}


	/*	NOTE: create new file type list object
	 *	return the new object
	*/
	function createTypeListItem(object) {
		try {
			var newListEl = document.createElement('listitem');
			newListEl.setAttribute('label', object['ext']);
			newListEl.setAttribute('tooltiptext', object['ext']);
			newListEl['object'] = object;

			// newListEl.setAttribute('onclick', 'fillFileSettings(this["object"]);');

			return newListEl;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}

	/*	NOTE: remove a type from the list
	 *	return true/false depending if a type has been selected
	*/
	function removeFileType() {
		try {
			var newTypeEl = document.getElementById('addtype');
			var newType = document.getElementById('addtype').value;
			if (newType != ''){
				var confirmed = confirm(firefly_getPref('locale','chrome://firefly/locale/options.properties', 'fileTypesPrefpane.removeTypeSure'));
				if (!confirmed) {
					return false;
				}
				if (newType.substr(0,1) == '-') {
					return false;
				}
				var fileTypesList = document.getElementById('fileTypesList');
				for (var i = 0;i< fileTypesList.childNodes.length;i++) {
					if (fileTypesList.childNodes[i]['object']['ext'] == newType) {
						fileTypesList.removeChild(fileTypesList.childNodes[i])
						break;
					}
				}

				newTypeEl.value = '';

				// loadFileTypesList();
				zeroFileSettings();
				zeroProgramDetails();
				disableFileSettings();
				setTimeout("firefly_fireEvent('change',document.getElementById('fileTypesList'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
				return true;
			}
			return false;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: rename the file type
	 *	return true/false
	*/
	function renameFileType() {
		try {
			var newTypeEl = document.getElementById('addtype');
			var newType = document.getElementById('addtype').value;
			if (newType != ''){
				/*var fileTypes = firefly_getPref('pref','complex','extensions.firefly.fileTypes');
				fileTypes = deserialize(fileTypes);
				if (fileTypes == null) {
					fileTypes = new Object();
				}

				var selectedType = document.getElementById('fileTypesList').selectedItem;
				fileTypes[newType] = fileTypes[selectedType.label];
				fileTypes[newType]['ext'] = newType;
				delete fileTypes[selectedType.label];

				fileTypes = serialize(fileTypes);
				firefly_setPref('pref','complex','extensions.firefly.fileTypes',fileTypes);*/

				var fileTypesList = document.getElementById('fileTypesList');
				var selectedType =fileTypesList.selectedItem;
				selectedType['object']['ext'] = newType;
				selectedType['object']['type'] = document.getElementById('mainType').value;
				selectedType.setAttribute('label', newType);

				// loadFileTypesList();
				setTimeout("firefly_fireEvent('change',document.getElementById('fileTypesList'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
				return true;
			}
		} catch (e) {
			firefly_Logger(e,'error');
		}
		return false;
	}


	/*	NOTE: load the type list
	 *	return true/false if there are/are not entered file types
	*/
	function loadFileTypesList() {
		try {
			var listEl = document.getElementById('fileTypesList');
			firefly_EraseContent(listEl);

			// var fileTypes = firefly_getPref('pref','complex','extensions.firefly.fileTypes');
			var fileTypes = document.getElementById('fileTypesPref').value;
			fileTypes = deserialize(fileTypes);
			if (fileTypes == null) {
				return false;
			}
			var arrFileTypes = new Array();
			for (var k in fileTypes) {
				arrFileTypes.push(k);
			}
			arrFileTypes.sort();
			for (var i = 0;i< arrFileTypes.length;i++) {
				var k = arrFileTypes[i];
				var newListEl = createTypeListItem(fileTypes[k]);
				listEl.appendChild(newListEl);
			}

			return true;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	function returnFileTypesString() {
		try {
			var fileTypes = new Object();
			var fileTypesList = document.getElementById('fileTypesList');
			for (var i = 0;i< fileTypesList.childNodes.length;i++) {
				var obj = fileTypesList.childNodes[i]['object'];
				fileTypes[obj['ext']] = obj;
			}

			fileTypes = serialize(fileTypes);
			return fileTypes;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}

	function saveFileTypesList() {
		try {
			var fileTypes = new Object();
			var fileTypesList = document.getElementById('fileTypesList');
			for (var i = 0;i< fileTypesList.childNodes.length;i++) {
				var obj = fileTypesList.childNodes[i]['object'];
				fileTypes[obj['ext']] = obj;
			}

			fileTypes = serialize(fileTypes);

			// return fileTypes;
			// document.getElementById('fileTypesPref').value = fileTypes;
			firefly_setPref('pref','complex','extensions.firefly.fileTypes',fileTypes);
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}

	/*	NOTE: fill setting entries when a type is selected
	 *	return true
	*/
	function fillFileSettings(obj) {
		try {
			enableFileSettings();
			zeroFileSettings();
			zeroProgramDetails();

			document.getElementById('addtype').value = obj['ext'];
			document.getElementById('mainType').value = obj['type'];

			if (obj['style']) {
				// alert(obj['style']['font-weight']);
				document.getElementById('pickColor').color = obj['style']['color'];
				document.getElementById('pickBold').checked = (obj['style']['font-weight'] == 'bold') ? true : false;
				document.getElementById('pickItalic').checked = (obj['style']['font-style'] == 'italic') ? true : false;
				// alert(obj['style']['font-family']);
				document.getElementById('fontBox').value = obj['style']['font-family'];
				/*for (var i = 0;i< document.getElementById('fontBox').childNodes[0].childNodes.length;i++) {
					if (document.getElementById('fontBox').childNodes[0].childNodes[i].label == obj['style']['font-family']) {
						setTimeout("document.getElementById('fontBox').selectedIndex = " + i, 2); // BUG: ??? for some reason the item is not selected sometimes unless there is timeout
						break;
					}
				}*/
			}
			if (obj['icons']) {
				// alert(obj['icons']['16picon']);
				document.getElementById('32picon').src = obj['icons']['32'];
				document.getElementById('16picon').src = obj['icons']['16'];
			}

			fillPrograms();

			updateExampleStyle();
			return true;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: sets all settings entries to defaults
	 *	return true
	*/
	function zeroFileSettings() {
		try {
			document.getElementById('addtype').value = '';
			document.getElementById('pickColor').color = '#000000';
			document.getElementById('pickBold').checked = false;
			document.getElementById('pickItalic').checked = false;
			document.getElementById('fontBox').selectedIndex = 0;
			document.getElementById('mainType').value = 'other';


			document.getElementById('32picon').src = 'about:blank';
			document.getElementById('16picon').src = 'about:blank';
			return true;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: disable all settings entries when there is no type selected
	 *	return true
	*/
	function disableFileSettings() {
		try {
			for (var i = 0;i< arrIds.length;i++) {
				document.getElementById(arrIds[i]).disabled = true;
			}
			return true;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: enable all setting entries where a type is selectes
	 *	return true
	*/
	function enableFileSettings() {
		try {
			for (var i = 0;i< arrIds.length;i++) {
				document.getElementById(arrIds[i]).disabled = false;
			}
			document.getElementById('pickColor').color = '#000000';
			return true;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: executed when a style option is chosen to update what is needed
	 *	return true
	*/
	function chooseStyle(what) {
		try {
			var fileType = getCurrentType();
			var obj = fileType['object'];
			if (obj['icons'] == null) {
				obj['icons'] = new Object();
			}
			if (obj['style'] == null) {
				obj['style'] = new Object();
			}
			switch (what) {
				case 'color':
					obj['style']['color'] = document.getElementById('pickColor').color;
					break;
				case 'font-weight':
					if (document.getElementById('pickBold').checked == false) {
						var style = 'bold';
					} else {
						var style = 'normal';
					}
					obj['style']['font-weight'] = style;
					break;
				case 'font-style':
					if (document.getElementById('pickItalic').checked == false) {
						var style = 'italic';
					} else {
						var style = 'normal';
					}
					obj['style']['font-style'] = style;
					break
				case 'font-family':
					obj['style']['font-family'] = document.getElementById('fontBox').selectedItem.label;
					break;
				case '32picon':
					getIcon(32);
					obj['icons']['32'] = document.getElementById('32picon').src;
					break;
				case '16picon':
					getIcon(16);
					obj['icons']['16'] = document.getElementById('16picon').src;
					break;
			}
			updateExampleStyle();
			setTimeout("firefly_fireEvent('change',document.getElementById('fileTypesList'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
			return true;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: get icon for the current filetype and copy it to skin/classic/mime/
	 *	size - the icon size: 32/16 - depending on that they are written to subfolder 32 or 16
	 *	return - true/false - depending on if there was not/was error copying file
	*/
	function getIcon(size) {
		try {
			var nsIFilePicker=Components.interfaces.nsIFilePicker
			var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
			fp.init(window, firefly_getPref('locale','chrome://firefly/locale/options.properties', 'fileTypesPrefpane.' + size + 'piconChooseDialog'), nsIFilePicker.modeOpen);
			fp.appendFilters(nsIFilePicker.filterImages);

			var rv = fp.show();
			if (rv == nsIFilePicker.returnOK) {
				/*var GUID = "firefly.filemanager@gmail.com";
				var nsIExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
					.getService(Components.interfaces.nsIExtensionManager);
				var extDir=nsIExtensionManager.getInstallLocation(GUID).getItemLocation(GUID);*/
				var extDir = firefly_GetExtensionDir();
				extDir.append('chrome');
				extDir.append('skin');
				extDir.append('classic');
				extDir.append('mime');

				var file = fp.file;
				if (size==32) {
					extDir.append('32');
					try {
						file.copyTo(extDir,null);
					} catch (e) {
						/*if (e['name'] != NS_ERROR_FILE_ALREADY_EXISTS) {
							return;
						}*/
					}
					document.getElementById('32picon').src='chrome://firefly/skin/mime/32/'+file.leafName;
				} else {
					extDir.append('16');
					try {
						file.copyTo(extDir,null);
					} catch (e) {
						/*if (e['name'] != NS_ERROR_FILE_ALREADY_EXISTS) {
							return;
						}*/
					}

					document.getElementById('16picon').src='chrome://firefly/skin/mime/16/'+file.leafName;
				}
			}
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: get the currently chosen list item
	 *	return the listitem that is chosen
	*/
	function getCurrentType() {
		try {
			var type = document.getElementById('addtype').value;
			if (type == '') {
				return false;
			}
			var fileTypesList = document.getElementById('fileTypesList');
			for (var i = 0;i< fileTypesList.childNodes.length;i++) {
				if (fileTypesList.childNodes[i]['object']['ext'] == type) {
					// var obj = fileTypesList.childNodes[i]['object'];
					break
				}
			}
			return fileTypesList.childNodes[i];
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: updates the example string with the chosen styles
	 *	return true/false depending on whether there is chosen style
	*/
	function updateExampleStyle() {
		try {
			var exampleStyle = document.getElementById('exampleStyle');
			var fileType = getCurrentType();
			var style = '';
			if (fileType['object']['style'] != null) {
				for (var k in fileType['object']['style']) {
					style += k + ':' + fileType['object']['style'][k] + ';';
				}
			}
			exampleStyle.setAttribute('style', style);
			return false;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: fill the select with all system available fonts
	 *	return true
	*/
	function fillFontBox(fontBox) {
		try {
			fontBox = document.getElementById(fontBox).childNodes[0];
			var fontInstance = Components.classes["@mozilla.org/gfx/fontenumerator;1"].createInstance(Components.interfaces.nsIFontEnumerator);
			var allFonts = fontInstance.EnumerateAllFonts({});

			var newFontItem = document.createElement('menuitem');
			newFontItem.setAttribute('label', '-');
			fontBox.appendChild(newFontItem);

			for (var i = 0;i< allFonts.length;i++) {
				var newFontItem = document.createElement('menuitem');
				newFontItem.setAttribute('label', allFonts[i]);
				newFontItem.setAttribute('value', allFonts[i]);
				fontBox.appendChild(newFontItem);
			}
			return true;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: display file picker to choose a program
	 *	return true
	*/
	function chooseProgram() {
		try {
			var nsIFilePicker = Components.interfaces.nsIFilePicker;
			var picker=nsIFilePicker.modeOpen;
			var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
			fp.init(window,  firefly_getPref('locale','chrome://firefly/locale/options.properties', 'fileTypesPrefpane.chooseProgram'), picker);
			fp.appendFilters(nsIFilePicker.filterApps);//# Available filters: filterAll, filterHTML, filterText, filterImages, filterXML, filterXUL, filterApps.
			fp.filterIndex=nsIFilePicker.filterApps;
			var res = fp.show();
			if (res == nsIFilePicker.returnOK){
				var thefile = fp.file;
				document.getElementById('addProgram').value = thefile.path;
			}
			return true;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: add program to the list
	 *	return true/false
	*/
	function addProgram() {
		try {
			var newType = document.getElementById('addtype').value;
			if (newType != ''){
				var fileType = getCurrentType()['object'];

				if (fileType['programs'] == null) {
					fileType['programs'] = new Array();
				}
				var newProgram = new Object();

				if (document.getElementById('addProgramRelative').checked) {
					var mozillaDir = firefly_GetMozillaDir();
					var startMozillaDir = mozillaDir;
					var relativeProgram = firefly_GetFile(document.getElementById('addProgram').value);
					var numParents = 0;
					try {
						while (mozillaDir.parent) {
							if (relativeProgram.parent.path == '/..') {    // NOTE: MacOS X behaviour - there is always parent... fixed in Fx3
								break;
							}
							numParents++;
							if (relativeProgram.path.indexOf(mozillaDir.parent.path) != -1) {
								var commonPath = mozillaDir.parent.path;
								var relativePath = relativeProgram.path.substr(mozillaDir.parent.path.length);
								var relativePathUps = '';
								var separator = firefly_getPref('pref','char','extensions.firefly.separator');
								for (var i = 0;i< numParents;i++) {
									relativePathUps += separator + '..';
								}
								var newPath = relativePathUps + relativePath;
								break;
							}
							mozillaDir = mozillaDir.parent;
						}
					} catch (e) {
					}
				} else {
					var newPath = document.getElementById('addProgram').value;
				}

				newProgram['path'] = newPath;
				newProgram['name'] = document.getElementById('addProgramCaption').value;
				newProgram['arguments'] = document.getElementById('addProgramArguments').value;
				newProgram['relative'] = document.getElementById('addProgramRelative').checked;

				if (document.getElementById('setDefaultProgram').checked) {
					fileType['defaultProgram'] = newPath;//document.getElementById('addProgram').value;
				}

				fileType['programs'].push(newProgram);

				zeroProgramDetails();
				fillPrograms();
				setTimeout("firefly_fireEvent('change',document.getElementById('fileTypesList'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
				return true;
			}
			return false;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: remove program from the list
	 *	return true/false
	*/
	function removeProgram() {
		try {
			var newType = document.getElementById('addtype').value;
			if (newType != ''){
				var fileType = getCurrentType()['object'];
				if (fileType['programs'] == null) {
					return false;
				}
				var newProgram = document.getElementById('addProgram').value;
				for (var i = 0;i< fileType['programs'].length;i++) {
					if (fileType['programs'][i] == undefined) {
						continue;
					}
					if (fileType['programs'][i]['path'] == newProgram) {
						if (fileType['programs'][i]['path'] == fileType['defaultProgram']) {
							fileType['defaultProgram'] = '';
						}
						delete fileType['programs'][i];
						break;
					}
				}

				var tmp = new Array();
				for (var i = 0;i< fileType['programs'].length;i++) {
					if (fileType['programs'][i] != undefined) {
						tmp.push(fileType['programs'][i]);
					}
				}
				fileType['programs'] = tmp;

				zeroProgramDetails();
				fillPrograms();
				setTimeout("firefly_fireEvent('change',document.getElementById('fileTypesList'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
				return true;
			}
			return false;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: edit program from the list
	 *	return true/false
	*/
	function editProgram() {
		try {
			var newType = document.getElementById('addtype').value;
			if (newType != ''){
				var fileType = getCurrentType()['object'];

				if (fileType['programs'] == null) {
					return false
				}

				var filePrograms = document.getElementById('filePrograms').selectedItem['program'];

				for (var i = 0;i< fileType['programs'].length;i++) {
					if (fileType['programs'][i] == undefined) {
						continue;
					}
					if (fileType['programs'][i]['path'] == filePrograms['path']) {
						if (document.getElementById('setDefaultProgram').checked) {
							fileType['defaultProgram'] = document.getElementById('addProgram').value;
						} else if (fileType['defaultProgram'] == filePrograms['path']) {
							fileType['defaultProgram'] = '';
						}

						fileType['programs'][i]['path'] = document.getElementById('addProgram').value
						fileType['programs'][i]['name'] = document.getElementById('addProgramCaption').value
						fileType['programs'][i]['arguments'] = document.getElementById('addProgramArguments').value
						fileType['programs'][i]['relative'] = document.getElementById('addProgramRelative').checked

						break;
					}
				}

				zeroProgramDetails();
				fillPrograms();
				setTimeout("firefly_fireEvent('change',document.getElementById('fileTypesList'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
				return true;
			}
			return false;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: empties the program details settings
	 *	return true
	*/
	function zeroProgramDetails() {
		try {
			var programsBox = document.getElementById('filePrograms');
			firefly_EraseContent(programsBox);

			document.getElementById('addProgram').value = '';
			document.getElementById('addProgramCaption').value = '';
			document.getElementById('addProgramArguments').value = '';
			document.getElementById('addProgramRelative').checked = false;
			document.getElementById('setDefaultProgram').checked = false;

			document.getElementById('addProgramRelative').disabled = false;
			document.getElementById('editProgramButton').disabled = false;

			return true;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}

	/*	NOTE: fills the program list
	 *	return true
	*/
	function fillPrograms() {
		try {
			var fileType = getCurrentType()['object'];
			if (fileType['programs'] == null) {
				return false;
			}
			var programsBox = document.getElementById('filePrograms');
			for (var i = 0;i< fileType['programs'].length;i++) {
				if (fileType['programs'][i] == undefined) {
					continue;
				}
				var newProgram = document.createElement('listitem');

				if (fileType['defaultProgram'] == fileType['programs'][i]['path']) {
					newProgram.setAttribute('style', 'font-weight: bold;');
				}

				newProgram.setAttribute('label', fileType['programs'][i]['name']);
				newProgram.setAttribute('path', fileType['programs'][i]['path']);
				newProgram.setAttribute('relative', fileType['programs'][i]['relative']);

				newProgram['program'] = fileType['programs'][i];

				newProgram.setAttribute('onclick', 'fillThisProgram(this)');
				programsBox.appendChild(newProgram);
			}
			return true;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: when clicked on a program from the list fill the details
	 *	return true
	*/
	function fillThisProgram(el) {
		try {
			var fileType = getCurrentType()['object'];
			document.getElementById('addProgram').value = el['program']['path'];
			document.getElementById('addProgramArguments').value = el['program']['arguments'];
			document.getElementById('addProgramCaption').value = el['program']['name'];
			document.getElementById('addProgramRelative').checked = el['program']['relative'];

			document.getElementById('addProgramRelative').disabled = true;

			document.getElementById('setDefaultProgram').checked = (el['program']['path'] == fileType['defaultProgram']);
			document.getElementById('editProgramButton').disabled = false;
			if (el['program']['relative']) {
				document.getElementById('editProgramButton').disabled = true;
			}
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: move a program up or down the list
	 *	return true/false
	*/
	function moveProgram(direction,id) {
		try {
			var programsArray = getCurrentType()['object']['programs'];
			var listbox=document.getElementById(id);
			var selected=listbox.selectedIndex;
			var selectedItem=listbox.selectedItem;
			if (selectedItem == null) {
				return;
			}
			if (direction == 'up') {
				if (selected > 0) {
					// alert(programsArray[selected - 1] + '|' + programsArray[selected]);

					var tmp = programsArray[selected];
					programsArray[selected] = programsArray[selected - 1];
					programsArray[selected - 1] = tmp;

					// listbox.selectedIndex=selected - 1;
					setTimeout("document.getElementById('" + id + "').selectedIndex = " +(selected - 1), 1);

					firefly_EraseContent(listbox);
					fillPrograms();
				}
			} else if (direction == 'down') {
				if (selected < listbox.getRowCount() - 1) {
					// alert(programsArray[selected] + '|' + programsArray[selected + 1]);

					var tmp = programsArray[selected];
					programsArray[selected] = programsArray[selected + 1];
					programsArray[selected + 1] = tmp;

					setTimeout("document.getElementById('" + id + "').selectedIndex = " +(selected + 1), 1);

					firefly_EraseContent(listbox);
					fillPrograms();
				}
			}
			setTimeout("firefly_fireEvent('change',document.getElementById('fileTypesList'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	function acceptOptions() {
		try {
			saveFileTypesList();
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}

/************** End File Types **************/


/***************** Send To *****************/

	/*	NOTE: save Send To list
	 *
	*/
	function returnSendToString() {
		try {
			var sendTo = new Array();
			var sendToList = document.getElementById('sendToList');
			for (var i = 0;i< sendToList.childNodes.length;i++) {
				// var obj = sendToList.childNodes[i]['object'];
				var path = sendToList.childNodes[i]['path'];
				var alias = sendToList.childNodes[i]['alias'];

				sendTo[i] = new Array(path,alias);


			}

			sendTo = serialize(sendTo);
			return sendTo;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: load Send To list
	 *
	*/
	function loadSendToList() {
		try {
			var listEl = document.getElementById('sendToList');
			firefly_EraseContent(listEl);

			// var sendTo = firefly_getPref('pref','complex','extensions.firefly.sendTo');
			var sendTo = document.getElementById('sendToPref').value;
			sendTo = deserialize(sendTo);
			if (sendTo == null) {
				return false;
			}
			// alert(sendTo);
			// return;
			for (var i = 0;i< sendTo.length;i++) {

				var k = sendTo[i];
				var newListEl = document.createElement('listitem');

				if (sendTo[i][1] != '') {
					var alias = ' (' + sendTo[i][1] + ')';
				} else {
					var alias = '';
				}
				// alert(sendTo[i][0] + alias);
				newListEl.setAttribute('label',sendTo[i][0] + alias);
				newListEl.setAttribute('tooltiptext',sendTo[i][0] + alias);

				// newListEl.setAttribute('label',sendTo[i]);
				newListEl.setAttribute('onclick','loadSendToItem(this);');
				newListEl['path'] = sendTo[i][0];
				newListEl['alias'] = sendTo[i][1];
				listEl.appendChild(newListEl);
			}

			return true;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: load settings when entry is clicked
	 *
	*/
	function loadSendToItem(el) {
		try {
			document.getElementById('sendToUpdateButton').disabled = false;
			document.getElementById('sendToRemoveButton').disabled = false;
			document.getElementById('sendToAliasBox').value = el.alias;
			document.getElementById('sendToPathBox').value = el.path;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: add new Send To entry
	 *
	*/
	function sendToAdd() {
		try {
			if (document.getElementById('sendToPathBox').value != '') {
				var listbox = document.getElementById('sendToList');
				var newEl = document.createElement('listitem');
				if (document.getElementById('sendToAliasBox').value != '') {
					var alias = ' (' + document.getElementById('sendToAliasBox').value + ')';
				} else {
					var alias = '';
				}
				newEl.setAttribute('label',document.getElementById('sendToPathBox').value + alias);
				newEl.setAttribute('onclick','loadSendToItem(this);');
				newEl['path'] = document.getElementById('sendToPathBox').value;
				newEl['alias'] = document.getElementById('sendToAliasBox').value;
				// newEl['type'] = document.getElementById('typeBox').value;

				listbox.appendChild(newEl);

				setTimeout("firefly_fireEvent('change',document.getElementById('sendToList'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
			}
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: update Send To entry
	 *
	*/
	function sendToUpdate() {
		try {
			if (document.getElementById('sendToPathBox').value != '') {
				var listbox = document.getElementById('sendToList');
				var listitem = listbox.getItemAtIndex(listbox.selectedIndex);

				if (document.getElementById('sendToAliasBox').value != '') {
					var alias = ' (' + document.getElementById('sendToAliasBox').value + ')';
				} else {
					var alias = '';
				}
				listitem.setAttribute('label',document.getElementById('sendToPathBox').value + alias);
				listitem['path'] = document.getElementById('sendToPathBox').value;
				listitem['alias'] = document.getElementById('sendToAliasBox').value;
				// listitem['type'] = document.getElementById('typeBox').value;
				setTimeout("firefly_fireEvent('change',document.getElementById('sendToList'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
			}
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: remove Send To entry
	 *
	*/
	function sendToRemove() {
		try {
			var listbox = document.getElementById('sendToList');
			// var listitem = listbox.getItemAtIndex(listbox.selectedIndex);
			listbox.removeItemAt(listbox.selectedIndex);
			if (listbox.childNodes.length > 0) {
				listbox.selectItem(listbox.getItemAtIndex(0));
			}
			setTimeout("firefly_fireEvent('change',document.getElementById('sendToList'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	function sendToMove(direction) {
		try {
			var listbox = document.getElementById('sendToList');
			var selected = listbox.selectedIndex;
			if (selected != -1) {
				var selectedItem = listbox.getItemAtIndex(selected);
			} else {
				selected = 0;
				var selectedItem = listbox.getItemAtIndex(selected);
				listbox.selectItem(selectedItem);
			}
			if (direction == 'up') {
				if (selected > 0) {
					var movedEl = listbox.insertItemAt(selected - 1,selectedItem.label,selectedItem.value);
					movedEl['path'] = selectedItem['path'];
					movedEl['alias'] = selectedItem['alias'];
					movedEl['type'] = selectedItem['type'];
					movedEl.setAttribute('onclick','loadSendToItem(this);');

					listbox.removeItemAt(selected + 1);
					listbox.selectItem(movedEl);
				}
			} else if (direction == 'down') {
				if (selected < listbox.getRowCount()) {
					selectedItem = listbox.getItemAtIndex(selected+1);
					var movedEl = listbox.insertItemAt(selected,selectedItem.label,selectedItem.value);
					movedEl['path'] = selectedItem['path'];
					movedEl['alias'] = selectedItem['alias'];
					movedEl['type'] = selectedItem['type'];
					movedEl.setAttribute('onclick','loadSendToItem(this);');

					listbox.removeItemAt(selected + 2);
				}
			}
			setTimeout("firefly_fireEvent('change',document.getElementById('sendToList'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: browse for folder
	 *
	*/
	function browseForSendTo() {
		try {
			var nsIFilePicker = Components.interfaces.nsIFilePicker;
			var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
			fp.init(window, firefly_getPref('locale','chrome://firefly/locale/startPageSettings.properties','firefly_chooseFileOrFolder'), nsIFilePicker.modeGetFolder);
			var res = fp.show();
			if (res == nsIFilePicker.returnOK){
				var thefile = fp.file;
				document.getElementById('sendToPathBox').value=thefile.path;
			}
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}

/*************** End Send To ***************/


/***************** Sidebar *****************/

	/*	NOTE: choose background image for start page
	 *
	*/
	function browseForBgImage() {
		try {
			var nsIFilePicker = Components.interfaces.nsIFilePicker;
			var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
			fp.init(window,  firefly_getPref('locale','chrome://firefly/locale/startPageSettings.properties','firefly_chooseBackgroundImage'), nsIFilePicker.modeOpen);
			fp.appendFilters(nsIFilePicker.filterImages);
			var res = fp.show();
			if (res == nsIFilePicker.returnOK){
				var thefile = fp.file;
				document.getElementById('firefly_startPageBackgroundImage').value=thefile.path;
			}
			setTimeout("firefly_fireEvent('change',document.getElementById('firefly_startPageBackgroundImage'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: load tree list
	 *
	*/
	function loadTreeList() {
		try {
			var listEl = document.getElementById('treeList');
			firefly_EraseContent(listEl);

			// var sendTo = firefly_getPref('pref','complex','extensions.firefly.sendTo');
			var tree = document.getElementById('treePref').value;
			tree = deserialize(tree);
			var treeList = document.getElementById('treeList');
			for (var i = 0; i < tree.length;i++) {
				var newList = document.createElement('listitem');
				if (tree[i].alias != '') {
					var alias = ' (' + tree[i].alias + ')';
				} else {
					var alias = '';
				}
				newList.setAttribute('label',tree[i].path + alias);
				newList['alias'] = tree[i].alias;
				newList['type'] = tree[i].type;
				newList['path'] = tree[i].path;

				newList.setAttribute('onclick', 'loadTreeItem(this);');
				// newList.setAttribute('onkeypress', 'removeItem(event,this);');

				treeList.appendChild(newList);
			}

			return true;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: save tree list to pref
	 *
	*/
	function returnTreeString() {
		try {
			var tree = new Array();
			var treeList = document.getElementById('treeList');
			for (var i = 0; i < treeList. getRowCount();i++) {
				var listitem = treeList.getItemAtIndex(i);
				tree[i] = new Object();
				tree[i]['path'] = listitem['path'];
				tree[i]['alias'] = listitem['alias'];
				tree[i]['type'] = listitem['type'];
			}

			tree = serialize(tree);
			return tree;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: move tree entries up/down
	 *
	*/
	function moveTree(direction) {
		try {
			var listbox = document.getElementById('treeList');
			var selected = listbox.selectedIndex;
			if (selected != -1) {
				var selectedItem = listbox.getItemAtIndex(selected);
			} else {
				selected = 0;
				var selectedItem = listbox.getItemAtIndex(selected);
				listbox.selectItem(selectedItem);
			}
			if (direction == 'up') {
				if (selected > 0) {
					var movedEl = listbox.insertItemAt(selected - 1,selectedItem.label,selectedItem.value);
					movedEl['path'] = selectedItem['path'];
					movedEl['alias'] = selectedItem['alias'];
					movedEl['type'] = selectedItem['type'];
					movedEl.setAttribute('onclick','loadTreeItem(this);');

					listbox.removeItemAt(selected + 1);
					listbox.selectItem(movedEl);
				}
			} else if (direction == 'down') {
				if (selected < listbox.getRowCount()) {
					selectedItem = listbox.getItemAtIndex(selected+1);
					var movedEl = listbox.insertItemAt(selected,selectedItem.label,selectedItem.value);
					movedEl['path'] = selectedItem['path'];
					movedEl['alias'] = selectedItem['alias'];
					movedEl['type'] = selectedItem['type'];
					movedEl.setAttribute('onclick','loadTreeItem(this);');

					listbox.removeItemAt(selected + 2);
				}
			}
			setTimeout("firefly_fireEvent('change',document.getElementById('treeList'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: add new entry to tree
	 *
	*/
	function treeAdd() {
		try {
			if (document.getElementById('pathBox').value != '') {
				var listbox = document.getElementById('treeList');
				var newEl = document.createElement('listitem');
				if (document.getElementById('aliasBox').value != '') {
					var alias = ' (' + document.getElementById('aliasBox').value + ')';
				} else {
					var alias = '';
				}
				newEl.setAttribute('label',document.getElementById('pathBox').value + alias);
				newEl.setAttribute('onclick','loadTreeItem(this);');
				newEl['path'] = document.getElementById('pathBox').value;
				newEl['alias'] = document.getElementById('aliasBox').value;
				newEl['type'] = document.getElementById('typeBox').value;

				listbox.appendChild(newEl);

				setTimeout("firefly_fireEvent('change',document.getElementById('treeList'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
			}
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: update tree entry
	 *
	*/
	function treeUpdate() {
		try {
			if (document.getElementById('pathBox').value != '') {
				var listbox = document.getElementById('treeList');
				var listitem = listbox.getItemAtIndex(listbox.selectedIndex);

				if (document.getElementById('aliasBox').value != '') {
					var alias = ' (' + document.getElementById('aliasBox').value + ')';
				} else {
					var alias = '';
				}
				listitem.setAttribute('label',document.getElementById('pathBox').value + alias);
				listitem['path'] = document.getElementById('pathBox').value;
				listitem['alias'] = document.getElementById('aliasBox').value;
				listitem['type'] = document.getElementById('typeBox').value;

				setTimeout("firefly_fireEvent('change',document.getElementById('treeList'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
			}
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: remove tree entry
	 *
	*/
	function treeRemove() {
		try {
			var listbox = document.getElementById('treeList');
			// var listitem = listbox.getItemAtIndex(listbox.selectedIndex);
			listbox.removeItemAt(listbox.selectedIndex);
			listbox.selectItem(listbox.getItemAtIndex(0));

			setTimeout("firefly_fireEvent('change',document.getElementById('treeList'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: load tree enrty settings for edit
	 *
	*/
	function loadTreeItem(el) {
		try {
			document.getElementById('updateButton').disabled = false;
			document.getElementById('removeButton').disabled = false;
			document.getElementById('aliasBox').value = el.alias;
			document.getElementById('pathBox').value = el.path;
			document.getElementById('typeBox').value = el.type;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: browse for folder to add in the tree
	 *
	*/
	function browseForTreeFolder() {
		try {
			var nsIFilePicker = Components.interfaces.nsIFilePicker;
			var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
			fp.init(window, firefly_getPref('locale','chrome://firefly/locale/startPageSettings.properties','firefly_chooseFileOrFolder'), nsIFilePicker.modeGetFolder);
			var res = fp.show();
			if (res == nsIFilePicker.returnOK){
				var thefile = fp.file;
				document.getElementById('pathBox').value=thefile.path;
			}
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}

/*************** End Sidebar ***************/


/************** Kbd Shortcuts **************/

	//	NOTE: char to code array
		var codesToKeys = new Object();
		codesToKeys['123'] = 'VK_F12';
		codesToKeys['122'] = 'VK_F11';
		codesToKeys['121'] = 'VK_F10';
		codesToKeys['120'] = 'VK_F9';
		codesToKeys['119'] = 'VK_F8';
		codesToKeys['118'] = 'VK_F7';
		codesToKeys['117'] = 'VK_F6';
		codesToKeys['116'] = 'VK_F5';
		codesToKeys['115'] = 'VK_F4';
		codesToKeys['114'] = 'VK_F3';
		codesToKeys['113'] = 'VK_F2';
		codesToKeys['112'] = 'VK_F1';
		codesToKeys['13'] = 'VK_RETURN';
		codesToKeys['27'] = 'VK_ESCAPE';
		codesToKeys['36'] = 'VK_HOME';
		codesToKeys['35'] = 'VK_END';
		codesToKeys['8'] = 'VK_BACK';
		codesToKeys['9'] = 'VK_TAB';
		codesToKeys['33'] = 'VK_PAGE_UP';
		codesToKeys['34'] = 'VK_PAGE_DOWN';
		codesToKeys['45'] = 'VK_INSERT';
		codesToKeys['46'] = 'VK_DELETE';
		codesToKeys['39'] = 'VK_RIGHT';
		codesToKeys['37'] = 'VK_LEFT';
		codesToKeys['38'] = 'VK_UP';
		codesToKeys['40'] = 'VK_DOWN';


	/*	NOTE: get the preference from the element and set it to the listitem
	 *	pref - preference ID
	 *	elid - ID if the current listitem
	*/
	function getKbdPref(pref, elid) {
		try {
			var kbdObject = document.getElementById(pref).value;
			kbdObject = deserialize(kbdObject);
			document.getElementById(elid)['kbdSetting'] = kbdObject;

			var shortcut = '';
			if (kbdObject['ctrlKey'] == true) {
				shortcut += 'Ctrl+';
			}
			if (kbdObject['shiftKey'] == true) {
				shortcut += 'Shift+';
			}
			if (kbdObject['altKey'] == true) {
				shortcut += 'Alt+';
			}
			if (kbdObject['charCode'] != '') {
				shortcut += String.fromCharCode(kbdObject['charCode']);
			} else if (kbdObject['keyCode'] != '') {
				shortcut += codesToKeys[kbdObject['keyCode']];
			}
			document.getElementById(elid).childNodes[1].setAttribute('label', shortcut);
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: set the value of the preference
	 *	elid - ID of the current listitem
	 *	return - serialized object containing the chosen kbd shortcut
	*/
	function setKbdPref(elid) {
		try {
			var kbdShortcut = document.getElementById(elid)['kbdSetting'];
			return serialize(kbdShortcut);
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: fill textbox with the current shortcut
	 *
	*/
	function fillKbdShortcut(event) {
		try {
			document.getElementById('newKbdHolder').style.display = '';
			document.getElementById('kbdShortcut').value = event.target.selectedItem.childNodes[1].getAttribute('label');
			document.getElementById('kbdShortcut').focus();
			document.getElementById('kbdShortcut')['shortcut'] = event.target.selectedItem['kbdSetting'];
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: fill the new shortcut when keys are pressed
	 *
	*/
	function chooseShortcut(event) {
		try {
			// dump('char:' + event.isChar + '->' + event.shiftKey + '+' + event.ctrlKey + '+' + event.altKey + '+' + event.charCode + '+' + event.keyCode + '\r\n');
			var shortcut = '';
			if (event['ctrlKey'] == true) {
				shortcut += 'Ctrl+';
			}
			if (event['shiftKey'] == true) {
				shortcut += 'Shift+';
			}
			if (event['altKey'] == true) {
				shortcut += 'Alt+';
			}

			if (event['charCode'] > 0) {
				shortcut += String.fromCharCode(event['charCode']);
			} else {
				// alert(event['keyCode']);
				shortcut += codesToKeys[event['keyCode']];
			}
				// shortcut += String.fromCharCode(event['charCode']);

			document.getElementById('kbdShortcut').value = shortcut;
			document.getElementById('kbdShortcut')['shortcut'] = event;
			return false;
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}


	/*	NOTE: save the shortcut when press OK
	 *
	*/
	function saveShortcut(el) {
		try {
			document.getElementById('kbdShortcutsList').selectedItem['kbdSetting']['shiftKey'] = el.previousSibling['shortcut']['shiftKey'];
			document.getElementById('kbdShortcutsList').selectedItem['kbdSetting']['ctrlKey'] = el.previousSibling['shortcut'].ctrlKey;
			document.getElementById('kbdShortcutsList').selectedItem['kbdSetting']['altKey'] = el.previousSibling['shortcut'].altKey;
			document.getElementById('kbdShortcutsList').selectedItem['kbdSetting']['altKey'] = el.previousSibling['shortcut'].altKey;
			document.getElementById('kbdShortcutsList').selectedItem['kbdSetting']['charCode'] = el.previousSibling['shortcut'].charCode;
			document.getElementById('kbdShortcutsList').selectedItem['kbdSetting']['keyCode'] = el.previousSibling['shortcut'].keyCode;

			document.getElementById('newKbdHolder').style.display = 'none';

			setTimeout("firefly_fireEvent('change',document.getElementById('" + document.getElementById('kbdShortcutsList').selectedItem.id + "'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
		} catch (e) {
			firefly_Logger(e,'error');
		}
	}

/************ End Kbd Shortcuts ************/


/******************* Help ******************/

	function hideHelp(id) {
		if (document.getElementById(id)) {
			document.getElementById(id).style.display = 'none';
		}
		document.getElementById(id+'Tip').style.display = 'none';
	}

	function displayHelp(id) {
		if (document.getElementById(id)) {
			document.getElementById(id).style.display = '';
		}
		document.getElementById(id+'Tip').style.display = '';
	}

/***************** End Help ****************/


function getPercent(event) {
	try {
		var position=event.clientX-event.target.boxObject.x;
		var percent=(position/event.target.boxObject.width)*100;
		return Math.round(percent)
	} catch (e) {
		firefly_Logger(e,'error');
	}
}
/*	NOTE: executed on startup
 *	return true
*/
function options_onload() {

	// NOTE: select pane to show based on a passed argument
	if (window.arguments) {
		var pane = window.arguments[0];
		switch (pane) {
			case 'sidebar':
				document.getElementById('firefly_options').showPane(document.getElementById('treeOptions'));
				break;
			case 'sendTo':
				document.getElementById('firefly_options').showPane(document.getElementById('sendTo'));
				break;
			case 'fileTypes':
				document.getElementById('firefly_options').showPane(document.getElementById('fileTypes'));
				break;
			case 'help':
				document.getElementById('firefly_options').showPane(document.getElementById('helpOptions'));
				break;
			case 'general':
			default:
				document.getElementById('firefly_options').showPane(document.getElementById('general'));
				break;
		}
	}


	// loadFileTypesList();
	disableFileSettings();
	fillFontBox('fontBox');


	// NOTE: choose file type
		if (window.arguments) {
			var chosenFileType = window.arguments[1];
			// alert(document.getElementById('fileTypesList').getAttribute('chosenFileType'));
			for (var i = 0;i< document.getElementById('fileTypesList').childNodes.length;i++) {
				if (document.getElementById('fileTypesList').childNodes[i].label == chosenFileType) {
					document.getElementById('fileTypesList').selectedIndex = i;
					fillFileSettings(document.getElementById('fileTypesList').childNodes[i]['object']);
				}
			}
		}
	// sizeToContent();
	return true;
}
window.addEventListener('load',options_onload,false);
