function doOK() {
	var os = firefly_GetOS();
	if (os == 'windows') {
		var hidden = document.getElementById('winHidden').checked;
		var readOnly = document.getElementById('winReadOnly').checked;
		var system = document.getElementById('winSystem').checked;
		var attribs = new Array();
		if (hidden) {
			attribs.push('+h');
		} else {
			attribs.push('-h');
		}
		if (readOnly) {
			attribs.push('+r');
		} else {
			attribs.push('-r');
		}
		if (system) {
			attribs.push('+s');
		} else {
			attribs.push('-s');
		}
		setAttrib(attribs);
	} else {
		var attribs = new Array();
		var rights = '';
		var ownRead = document.getElementById('linOwnRead').checked;
		var ownWrite = document.getElementById('linOwnWrite').checked;
		var ownExec = document.getElementById('linOwnExecute').checked;
		rights += (ownRead?'u+r':'u-r') + ',' + (ownWrite?'u+w':'u-w') + ',' + (ownExec?'u+x':'u-x');

		var grpRead = document.getElementById('linGroupRead').checked;
		var grpWrite = document.getElementById('linGroupWrite').checked;
		var grpExec = document.getElementById('linGroupExecute').checked;
		rights += (grpRead?'g+r':'g-r') + ',' + (grpWrite?'g+w':'g-w') + ',' + (grpExec?'g+x':'g-x');

		var othRead = document.getElementById('linOtherRead').checked;
		var othWrite = document.getElementById('linOtherWrite').checked;
		var othExec = document.getElementById('linOtherExecute').checked;
		rights += (othRead?'o+r':'o-r') + ',' + (othWrite?'o+w':'o-w') + ',' + (othExec?'o+x':'o-x');

		attribs.push(rights);
		setAttribLinux(attribs);
	}
	return true;
}
function doCancel() {
	return true;
}
var scanning = false;
var dirs = new Array();
var files = new Array();
var endDirs = new Array();
var totalFileSize = 0;
var file = '';
function getSizeAndContent() {
	try {
		if (scanning) {
			return;
		}
		scanning = true;
		if (dirs.length == 0) {
			scanning = false;
			dump('done scanning\r\n');
			return;
		}
		var currentDir = dirs.shift();
		var [folderDirs,folderFiles,fileSize] = currentDir.getFolderEntries();
		dirs = dirs.concat(folderDirs);
		files = files.concat(folderFiles);
		totalFileSize = Math.ceil(totalFileSize) + fileSize;
		endDirs.push(currentDir);

		document.getElementById('fileSize').value = firefly_formatSize(totalFileSize);
		document.getElementById('dirsInFolder').value = endDirs.length - 1;
		document.getElementById('filesInFolder').value = files.length;

		scanning = false;
		if (dirs.length > 0) {
			setTimeout('getSizeAndContent()','1');
			// this.scanDirs();
		} else {
			dump('done scanning\r\n');
		}
	} catch (e) {
		firefly_Logger(e,'error');
	}
}
function load() {
	try {
		var fileTypes = firefly_getPref('pref','complex','extensions.firefly.fileTypes');
		fileTypeSettings = deserialize(fileTypes);
		var aFile = window.arguments[0];
		file = aFile;
		[,,style,,,icon,type] = firefly_getSettingsForType(aFile);
		if (icon == '') {
			var icon = aFile.getIcon(32);
		}
		document.getElementById('fileIcon').src = icon;
		document.getElementById('fileName').value = aFile.leafName;
		document.getElementById('fileName').setAttribute('style', style);
		if (aFile.isDirectory()) {
			document.getElementById('extensionHolder').style.display = 'none';
			dirs.push(aFile);
			getSizeAndContent();
		} else {
			document.getElementById('rowContains').style.display = 'none';
			var newType = firefly_getPref('locale','chrome://firefly/locale/filebox.properties','filter.' + type.replace(/-/g,'_'));
			var ext = aFile.getFileExt();
			if (ext != '') {
				document.getElementById('fileExt').value = ext + ' ( ' + newType + ' )';
			} else {
				document.getElementById('extensionHolder').style.display = 'none';
			}
		}
		document.getElementById('filePath').value = aFile.path;
		document.getElementById('fileSize').value = aFile.getFileSize();
		document.getElementById('fileModified').value = aFile.getFileDate();

		var yes = firefly_getPref('locale','chrome://firefly/locale/properties.properties','yes');
		var no = firefly_getPref('locale','chrome://firefly/locale/properties.properties','no');
		document.getElementById('fileIsReadable').value = aFile.isReadable()?yes:no;
		document.getElementById('fileIsWritable').value = aFile.isWritable()?yes:no;
		document.getElementById('fileIsExecutable').value = aFile.isExecutable()?yes:no;
		document.getElementById('fileIsHidden').value = aFile.isHidden()?yes:no;
		document.getElementById('fileIsDir').value = aFile.isDirectory()?yes:no;
		document.getElementById('fileIsFile').value = aFile.isFile()?yes:no;
		document.getElementById('fileIsSymlink').value = aFile.isSymlink()?yes:no;
		document.getElementById('fileIsSpecial').value = aFile.isSpecial()?yes:no;
		var permArr = new Object();
		document.getElementById('filePermissions').value = aFile.getPermissions(permArr);

		var os = firefly_GetOS();
		if (os == 'windows') {
			document.getElementById('winHidden').checked = aFile.isHidden();
			document.getElementById('winReadOnly').checked = !aFile.isWritable();
			document.getElementById('winSystem').checked = aFile.isSpecial();
			document.getElementById('windowsAttribs').style.display = '';
		} else {
			document.getElementById('linOwnRead').checked = permArr['owner']['read'];
			document.getElementById('linOwnWrite').checked = permArr['owner']['write'];
			document.getElementById('linOwnExecute').checked = permArr['owner']['execute'];

			document.getElementById('linGroupRead').checked = permArr['group']['read'];
			document.getElementById('linGroupWrite').checked = permArr['group']['write'];
			document.getElementById('linGroupExecute').checked = permArr['group']['execute'];

			document.getElementById('linOtherRead').checked = permArr['other']['read'];
			document.getElementById('linOtherWrite').checked = permArr['other']['write'];
			document.getElementById('linOtherExecute').checked = permArr['other']['execute'];

			document.getElementById('linuxAttribs').style.display = '';
		}

		sizeToContent();
		moveToAlertPosition();
	} catch (e) {
		firefly_Logger(e,'error');
	}
}

function setAttrib(attribs) {
	try {
		arguments = new Array();
		arguments = arguments.concat(attribs);
		arguments.push(file.path);
		var attrib = Components.classes["@mozilla.org/file/directory_service;1"]
				 .getService(Components.interfaces.nsIProperties)
				 .get("SysD", Components.interfaces.nsIFile);
		attrib.append('attrib.exe');
		var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
		process.init(attrib);
		process.run(false, arguments, arguments.length);
	} catch (e) {
		firefly_Logger(e,'error');
	}
}
function setAttribLinux(attribs) {
	try {
		arguments = new Array();
		arguments = arguments.concat(attribs);
		arguments.push(file.path);
		var attrib = firefly_GetFile('/bin/chmod');
		/*var attrib = Components.classes["@mozilla.org/file/directory_service;1"]
				 .getService(Components.interfaces.nsIProperties)
				 .get("SysD", Components.interfaces.nsIFile);*/
		// attrib.append('chmod');
		var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
		process.init(attrib);
		process.run(false, arguments, arguments.length);
	} catch (e) {
		firefly_Logger(e,'error');
	}
}
