/*	NOTE: errors
 *
*/
/*Error: Component returned failure code: 0x80520001 (NS_ERROR_FILE_UNRECOGNIZED_PATH) [nsILocalFile.parent]
Source file: chrome://firefly/content/js/tree.js
Line: 151*/

/*Error: Component returned failure code: 0x80520015 (NS_ERROR_FILE_ACCESS_DENIED) [nsILocalFile.directoryEntries]
Source file: chrome://firefly/content/js/providers/file.js
Line: 177*/



function firefly_file_provider(path,showHidden, fileObj, simple) {
	try {
		if (simple == undefined) {
			simple = false;
		}
		if (fileObj == undefined || fileObj == null) {
			var file = Components.classes["@mozilla.org/file/local;1"].createInstance();
			if (file) {
				file.QueryInterface(Components.interfaces.nsILocalFile);
			} else {
				dump('Error creating instance');
				return false;
			}
			file.initWithPath(path);
		} else {
			file = fileObj;
			path = file.path;
		}
		this._path = path;
		this.file = file;
		if (showHidden == undefined) {
			this.showHidden = false;
		} else {
			this.showHidden = showHidden;
		}

		try {
			this.path = file.path;
			this.leafName = file.leafName;
			this.permissions = file.permissions;
			this.fileSize = file.fileSize;
			this.lastModifiedTime  = file.lastModifiedTime ;
		} catch (e) {
		}
	} catch (e) {
		firefly_Logger(e,'error');
	}
}

firefly_file_provider.prototype.getPermissions = function(permArray) {
	try {
		function getPermissionsByNumber(num) {
			var perms = new Object();
			switch (num) {
				case '7':
					perms['read'] = true;
					perms['write'] = true;
					perms['execute'] = true;
					var ret = 'rwx';
					break;
				case '6':
					perms['read'] = true;
					perms['write'] = true;
					perms['execute'] = false;
					var ret = 'rw-';
					break;
				case '5':
					perms['read'] = true;
					perms['write'] = false;
					perms['execute'] = true;
					var ret = 'r-x';
					break;
				case '4':
					perms['read'] = true;
					perms['write'] = false;
					perms['execute'] = false;
					var ret = 'r--';
					break;
				case '3':
					perms['read'] = false;
					perms['write'] = true;
					perms['execute'] = true;
					var ret = '-wx';
					break;
				case '2':
					perms['read'] = false;
					perms['write'] = true;
					perms['execute'] = false;
					var ret = '-w-';
					break;
				case '1':
					perms['read'] = false;
					perms['write'] = false;
					perms['execute'] = true;
					var ret = '--x';
					break;
				case '0':
					perms['read'] = false;
					perms['write'] = false;
					perms['execute'] = false;
					var ret = '---';
					break;
				default:
					perms['read'] = false;
					perms['write'] = false;
					perms['execute'] = false;
					break;
			}
			return [ret,perms];
		}
		var permissions = this.permissions;
		var octalPermissions = permissions.toString(8);
		var last = octalPermissions.substr(octalPermissions.length-1,1);
		var middle = octalPermissions.substr(octalPermissions.length-2,1);
		var first = octalPermissions.substr(octalPermissions.length-3,1);

		if (permArray == undefined) {
			var permArray = new Object();
		}
		var [strfirst,arrfirst] = getPermissionsByNumber(first);
		var [strmiddle,arrmiddle] = getPermissionsByNumber(middle);
		var [strlast,arrlast] = getPermissionsByNumber(last);
		permArray['owner'] = arrfirst;
		permArray['group'] = arrmiddle;
		permArray['other'] = arrlast;
		var perm = strfirst + strmiddle + strlast;

		return perm;
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return '';
}
firefly_file_provider.prototype.isDirectory = function() {
	return this.file.isDirectory();
}
firefly_file_provider.prototype.isSymlink = function() {
	return this.file.isSymlink();
}
firefly_file_provider.prototype.isReadable = function() {
	return this.file.isReadable();
}
firefly_file_provider.prototype.isWritable = function() {
	return this.file.isWritable();
}
firefly_file_provider.prototype.isExecutable = function() {
	return this.file.isExecutable();
}
firefly_file_provider.prototype.isFile = function() {
	return this.file.isFile();
}
firefly_file_provider.prototype.isSpecial = function() {
	return this.file.isSpecial();
}
firefly_file_provider.prototype.isHidden = function() {
	return this.file.isHidden();
}
firefly_file_provider.prototype.getFileDate = function() {
	try {
		var date = new Date();
		date.setTime(this.lastModifiedTime);
		var day = date.getDate();
		if (day < 10) {
			day = '0' + day.toString();
		}
		var month = date.getMonth();
		month = month + 1;
		if (month < 10) {
			month = '0' + month.toString();
		}
		var year = date.getFullYear();
		var hour = date.getHours();
		if (hour < 10) {
			hour = '0' + hour.toString();
		}
		var minute = date.getMinutes();
		if (minute < 10) {
			minute = '0' + minute.toString();
		}
		var second = date.getSeconds();
		if (second < 10) {
			second = '0' + second.toString();
		}
		return day + '.' + month + '.' + year + '  ' + hour + ':' + minute + ':' + second;
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return '';
}
firefly_file_provider.prototype.getFileExt = function() {
	try {
		if (this.isDirectory()) {
			return '';
		} else {
			if (this.leafName.lastIndexOf('.') == -1) {
				return '';
			}
			var ext=this.leafName.substr(this.leafName.lastIndexOf('.')+1);
			return ext;
		}
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return '';
}
firefly_file_provider.prototype.getIcon = function(size) {
	if (size == undefined) {
		size = 16;
	}
	return 'moz-icon:file://' + this.path + '?size=' + size;
}
firefly_file_provider.prototype.getFileSize = function() {
	return firefly_formatSize(this.fileSize);
}
firefly_file_provider.prototype.getTarget = function() {
	this.file.followLinks = true;
	return this.file.target;
}
firefly_file_provider.prototype.getFolderEntries = function() {
	try {
		// alert(this.dot_files_as_hidden);
		var showHidden = this.showHidden;
		if (!this.file.isDirectory()) {
			//alert('This is not a folder');
			return false;
		}
		var folderDirs= new Array();
		var folderFiles= new Array();
		var fileSize = 0;
		try {
			folderDirs.unshift(this.file);
			var folderNum = folderDirs.length;
			var currentFolder = 0;

			if (folderDirs[currentFolder].getDirectoryEntries) {
				var folderEntries = folderDirs[currentFolder].getDirectoryEntries();
			} else {
				var folderEntries=folderDirs[currentFolder].directoryEntries;
			}
			while(folderEntries.hasMoreElements()) {
				try {
					var next=folderEntries.getNext().QueryInterface(Components.interfaces.nsILocalFile);
					if ((!showHidden && !next.isHidden()) || showHidden) {
						if (!showHidden && this.dot_files_as_hidden && next.leafName.substr(0,1) == '.') {
							continue;
						}
						if (next.isDirectory()) {
							next = new firefly_file_provider(next.path,showHidden,next);
							folderDirs.push(next);
						} else {
							next = new firefly_file_provider(next.path,showHidden,next);
							fileSize += next.fileSize;
							folderFiles.push(next);
						}
					}
				} catch (err) {
				}
			}
			folderDirs.shift(); // remove starting folder
		} catch (err) {
			// dump('error: ' + err.toSource() + '\r\n');
		}
		// dump(folderDirs.length + '|' + folderFiles.length + '\r\n');
		return [folderDirs,folderFiles,fileSize];
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return new Array();
}
firefly_file_provider.prototype.hasChildren = function() {
	try {
		var showHidden = this.showHidden;
		if (!this.file.isDirectory()) {
			//alert('This is not a folder');
			return false;
		}
		var hasChildren = false;
		try {
			var folderEntries=this.file.directoryEntries;
			while (folderEntries.hasMoreElements()) {
				try {
					var next=folderEntries.getNext().QueryInterface(Components.interfaces.nsILocalFile);
					if ((!showHidden && !next.isHidden()) || showHidden) {
						if (next.isDirectory()) {
							hasChildren = true;
							break;
						}
					}
				} catch (err) {
					alert(file.path);
				}
			}
		} catch (err) {
		}
		return hasChildren;
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return false;
}
firefly_file_provider.prototype.exists = function(){
	return this.file.exists();
}
firefly_file_provider.prototype.hasMoreElements = function(){
	return this.file.hasMoreElements();
}
firefly_file_provider.prototype.getDirectoryEntries = function(){
	return this.file.directoryEntries;
}

firefly_file_provider.prototype.getParent = function(){
	return this.file.parent;
}


firefly_file_provider.prototype.getFolderEntriesThread = function(recursive,id, type) {
	try {
		if (type == undefined) {
			type = 'list'; // for listing folders
		}
		var filters = new Object();
		var showHidden = this.showHidden;
		var startPath = this.path;
		firefly_dataReturn[id] = new Object();
		yield firefly_sleep(firefly_threadPriority);
		var files = new Array();
		var dirs = new Array();
		// var folder = this.file;
		var folder = this;
		dirs.push(this.file);
		var i = 0;
		while (folder = dirs[i]) {
			try {
				var file = null;
				if (folder.getDirectoryEntries) {
					var folderEntries = folder.getDirectoryEntries();
				} else {
					var folderEntries = folder.directoryEntries;
				}
				while (folderEntries.hasMoreElements()) {
					try {
						file=folderEntries.getNext().QueryInterface(Components.interfaces.nsILocalFile);
						if ((!showHidden && !file.isHidden()) || showHidden) {
							if (!showHidden && this.dot_files_as_hidden && file.leafName.substr(0,1) == '.') {
								continue;
							}
							file = new firefly_file_provider(file.path,showHidden,file);
							if (file.isDirectory()) {
								dirs.push(file);
							} else {
								var ext = file.getFileExt();
								if (ext != '') {
									filters[ext] = ext;
								}
								files.push(file);
							}
						}
					} catch (err) {
					}
					yield firefly_sleep(firefly_threadPriority);
				}
				if (!recursive) {
					break;
				}
				i++;
			} catch (err) {
				i++;
				// dump('error: ' + folder.path + '\r\n');
			}
			yield firefly_sleep(firefly_threadPriority);
		}
		dirs.shift(); // remove starting folder
		// dump('end: ' + dirs.length + '\r\n');
		// dump('end: ' + files.length + '\r\n');
		if (type == 'list') {
			firefly_dataReturn[id]['folderDirs'] = dirs;
			firefly_dataReturn[id]['folderFiles'] = files;
			firefly_dataReturn[id]['filters'] = filters;
		}

		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.notifyObservers(null,"firefly_filesChange",id);
	} catch (e) {
		firefly_Logger(e,'error');
	}
}
firefly_file_provider.prototype.getPopupBreadcrumbs = function() {
	try {
		function getMainDirs() {
			var folderDirs = new Array();
			var tree = firefly_getTree();
			for (var k in tree) {
				folderDirs.push(new firefly_file_provider(tree[k].path, this.showHidden));
			}
			return folderDirs;
		}
		try {
			if (this.file.parent && this.file.parent.path != '/..') {
				var newFileObj = new firefly_file_provider(this.file.parent.path,this.showHidden);
				// alert(newFileObj.path);
				var [folderDirs,] = newFileObj.getFolderEntries(false);
				return folderDirs;
			} else {
				return getMainDirs();
			}
		} catch (e) {
			return getMainDirs();
		}
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return null;
}
firefly_file_provider.prototype.getBreadcrumbs = function() {
	try {
		var breadcrumbs = new Array();
		try {
			var folder = this.file;
			breadcrumbs.unshift(new firefly_file_provider(folder.path,this.showHidden,folder));
			while(folder.parent) {
				if (folder.parent.path == '/..') {    // NOTE: MacOS X behaviour - there is always parent... fixed in Fx3
					break;
				}
				breadcrumbs.unshift(new firefly_file_provider(folder.parent.path,this.showHidden,folder.parent));
				folder = folder.parent;
			}
		} catch (e) {
		}
		return breadcrumbs;
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return null;
}
firefly_file_provider.prototype.getUpDirs = function(howMany) {
	try {
		var upDirs = new Array();
		var breadcrumbs = this.getBreadcrumbs();
		breadcrumbs.pop();
		var file;
		for (var i = 0; i< howMany; i++) {
			file = breadcrumbs.pop();
			if (file == undefined) break;
			upDirs.unshift(file);
		}
		return upDirs;
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return null;
}
firefly_file_provider.prototype.getOS = function() {
    var os = firefly_GetOS();
    return os;
}
firefly_file_provider.prototype.getFile = function() {
    return this.file;
}
firefly_file_provider.prototype.rename = function(newName) {
	try {
		this.file.moveTo(this.file.parent,newName);
	} catch (err) {
	}
}
firefly_file_provider.prototype.launchWithArgs = function(arguments) {
	try {
		var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
		process.init(this.file);
		process.run(false, arguments, arguments.length);
	} catch (err) {
	}
}
firefly_file_provider.prototype.execute = function() {
	try {
		switch (this.getOS().toLowerCase()) {
			case 'linux':
				try	{
					var isKDE = new firefly_file_provider('/var/run/kdm.pid');
					isKDE = isKDE.getFile();
				} catch (e) {}
				try {
					var isGNOME = new firefly_file_provider('/var/run/gdm.pid');
					isGNOME = isGNOME.getFile();
				} catch (e) {}
				var program = '/usr/bin/xdg-open';
				var hasExec = false;
				if (isKDE.isFile()) {
					program = '/usr/bin/kfmclient'; // NOTE: not always present in /usr/bin/ folder (Gentoo)
					var hasExec = true;
				} else if (isGNOME.isFile()) {
					program = '/usr/bin/gnome-open';
				}
				var linuxLaunch = new firefly_file_provider(program);
				if (hasExec) {
					linuxLaunch.launchWithArgs(new Array('exec',this._path));
				} else {
					linuxLaunch.launchWithArgs(new Array(this._path));
				}
				break;
			case 'windows':
			case 'macos':
			default:
				this.file.launch();
				break;
		}
	} catch (e) {
		firefly_Logger(e,'error');
	}
}
firefly_file_provider.prototype.createShortcut = function(name, inFolder) {
	try {
		if (inFolder == undefined) {
			inFolder = '';
		}
		if (name == undefined) {
			name = '';
		}
		if (this.getOS() != 'windows') {
			// use ln to create shortcut
			var arguments = '-s ';
			arguments += ' ' + this.file.path;

			if (inFolder != '') {
				arguments += ' ' + inFolder;
			}
			if (name != '') {
				arguments += name;
			}
			if (name == '' && inFolder == '') {
				arguments += ' ' + this.file.path + '.lnk';
			}
			arguments = arguments.replace(/\s+/g,' '); // replace multiple spaces with one
			arguments = arguments.split(' ');

			var ln = new firefly_file_provider('/bin/ln',true);
			var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
			process.init(ln.file);
			process.run(false, arguments, arguments.length);
		} else {
			// use mklnk to create shortcut
			var mklnk = firefly_GetExtensionDir();
			mklnk.append('mklnk');
			mklnk.append('mklnk.exe');

			var arguments = '';
			if (name != '') {
				arguments += ' ' + name;
			}
			if (inFolder != '') {
				arguments += ' -t ' + inFolder;
			}
			arguments += ' s1 ' + this.file.path;
			arguments = arguments.replace(/\s+/g,' '); // replace multiple spaces with one
			arguments = arguments.split(' ');
			var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
			process.init(mklnk);
			process.run(false, arguments, arguments.length);

			// alert(mklnk.path);
		}
	} catch (e) {
		firefly_Logger(e,'error');
	}
}

firefly_file_provider.prototype.createFolder = function() {
	var file = this.file;
	file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0774);
}
firefly_file_provider.prototype.createFile = function() {
	var file = this.file;
	file.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);
}
firefly_file_provider.prototype.createUniqueFile = function() {
	var file = this.file;
	file.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);
}

firefly_file_provider.prototype.writeFile = function(data) {
	try {
		// dump('writing file: ' + this.path + '\r\n');
		aFile = this.file;
		var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
		var outstream = Components.classes["@mozilla.org/binaryoutputstream;1"].createInstance(Components.interfaces.nsIBinaryOutputStream);
		outstream.setOutputStream (foStream);
		// use 0x02 | 0x10 to open file for appending.
		foStream.init(aFile, 0x02 | 0x10, 0664, 0); // write, append
		//foStream.write(data, data.length);
		outstream.writeBytes(data, data.length);
		foStream.close();
	} catch (e) {
		firefly_Logger(e,'error');
	}
}

firefly_file_provider.prototype.readFromStream = function(listener, newFile, transferEl, startPos) {
	try {
		// dump('reading file: ' + this.path + '\r\n');

		var aFile = this.file;

		var inStream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance( Components.interfaces.nsIFileInputStream );
		inStream.init(aFile,0x01, 00004, null);

		var transportService =Components.classes["@mozilla.org/network/stream-transport-service;1"].getService(Components.interfaces.nsIStreamTransportService);
		var transport = transportService.createInputTransport(inStream,startPos,-1,true);
		var stream = transport.openInputStream(0,0,0);

		var instream = Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream);
		instream.setInputStream (stream);

		var dataListener = {
			data : '',
			onStartRequest: function(request, context){},
			onStopRequest: function(request, context, status){
				instream.close();
				//outstream.close();
				listener.finished(this.data,context);
			},
			onDataAvailable: function(request, context, inputStream, offset, count){
				context = context.wrappedJSObject;
				// dump('new data to copy: ' + context + '\r\n');
				//this.data += instream.read(count);
				this.data = instream.readBytes(count);

				context.copiedSoFar = Math.ceil(context.copiedSoFar) + count;
				context.currentFilePosition = Math.ceil(context.currentFilePosition) + count;

				newFile.writeFile(this.data);
			}
		};

		var pump = Components.classes["@mozilla.org/network/input-stream-pump;1"].createInstance(Components.interfaces.nsIInputStreamPump);
		pump.init(stream, -1, -1, 0, 0, false);
		pump.asyncRead(dataListener,transferEl);

		this.pump=pump;
	} catch (e) {
		firefly_Logger(e,'error');
	}
}

firefly_file_provider.prototype.delFile = function(recursive) {
	this.file.remove(recursive);
}
// var file = firefly_provider('file', 'H:\\apache_root', true);
// firefly_GetWindow().firefly_startImmediate(file.getFolderEntriesThread(true));
// -------------- USAGE ---------------------------//
	/*var afile = new firefly_file_provider('c:\\users\\atg2d',false);
	var [folderDirs,folderFiles] = afile.getFolderEntries();
	for (var i = 0; i < folderDirs.length; i++) {
		// alert(folderDirs[i].path);
	}
	for (var i = 0; i < folderFiles.length; i++) {
		//alert(folderFiles[i].path);
	}

	var breadcrumbs = afile.getBreadcrumbs();
	for (var i = 0; i < breadcrumbs.length; i++) {
		//alert(breadcrumbs[i].path);
	}

	var upDirs = afile.getUpDirs(5);
	for (var i = 0; i < upDirs.length; i++) {
		alert('up - ' + upDirs[i].leafName);
	}

	var afile = new firefly_file_provider('C:\\Program Files\\Flock\\flock\\flock.exe');
	//afile.execute();
	*/
// ------------ END USEGE -------------------------//